/**
 * Copyright (c) 2009-2011 Zauber S.A. <http://www.zaubersoftware.com/>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

	
	/*
	 * Copyright (c) 2011 Zauber S.A.  -- All rights reserved
	 */
	
	package ar.com.zauber.commons.mom;

import java.lang.reflect.InvocationTargetException;
import java.util.List;

import org.apache.commons.beanutils.BeanUtilsBean;
import org.apache.commons.lang.Validate;

	
	/**
 * TODO: Description of the class, Comments in english by default  
 * 
 * 
 * @author Gaston Ponti
 * @since Aug 26, 2011
 */
@SuppressWarnings("unchecked")
public class CXFStyle extends BeanStyle
{
    public static final PropertyStyle STYLE  = new CXFStyle();
    

    /** @throws NoSuchMethodException 
     * @throws InvocationTargetException 
     * @throws IllegalAccessException 
     * @see ar.com.zauber.commons.mom.PropertyStyle#isSeteable(org.apache.commons.beanutils.BeanUtilsBean, org.apache.commons.beanutils.Map<String,Object>, org.apache.commons.beanutils.Object, java.lang.String) */
    public boolean isSeteable(BeanUtilsBean beanUtils, Object property, Object destination, String name) throws Exception
    {
        validateArguments(beanUtils,  destination, name);
        return super.isSeteable(beanUtils, property, destination, name) 
        	|| (beanUtils.getPropertyUtils().isReadable(destination, name) && List.class.isAssignableFrom(beanUtils.getPropertyUtils().getPropertyType(destination, name)));
    }

    /** @throws NoSuchMethodException 
     * @see ar.com.zauber.commons.mom.PropertyStyle#setValue(org.apache.commons.beanutils.BeanUtilsBean, org.apache.commons.beanutils.Map<String,Object>, org.apache.commons.beanutils.Object, java.lang.String) */
	public void setValue(BeanUtilsBean beanUtils, Object property, Object destination, String name) throws Exception
    {
		validateArguments(beanUtils, destination, name);
        if(List.class.isAssignableFrom(beanUtils.getPropertyUtils().getPropertyType(destination, name)))
        {
    		getListProperty(beanUtils, destination, name).addAll((List) property);
        }
        else
        {
            super.setValue(beanUtils, property, destination, name);
        }
    }

    /**
    	 * @param beanUtils
    	 * @param destination
    	 * @param name
    	 * @return
    	 * @throws IllegalAccessException
    	 * @throws InvocationTargetException
    	 * @throws NoSuchMethodException
    	 */
    public List getListProperty(BeanUtilsBean beanUtils, Object destination, String name)
        throws IllegalAccessException, InvocationTargetException, NoSuchMethodException
    {
        return ((List) beanUtils.getPropertyUtils().getProperty(destination, name));
    }

    /**
    	 * @param beanUtils
    	 * @param source
    	 * @param destination
    	 * @param name
    	 */
    public void validateArguments(BeanUtilsBean beanUtils,
                                  Object destination,
                                  String name)
    {
        Validate.notNull(name);
        Validate.notNull(destination);
        Validate.notNull(beanUtils);
    }
}

	